// Copyright lowRISC contributors.
// Licensed under the Apache License, Version 2.0, see LICENSE for details.
// SPDX-License-Identifier: Apache-2.0

module tb;

  import uvm_pkg::*;
  import dv_utils_pkg::*;
  import xbar_test_pkg::*;


  wire clk, rst_n;
  clk_rst_if clk_rst_if(.clk(clk), .rst_n(rst_n));

  xbar_main dut(
    .clk_main_i(clk),
    .rst_main_ni(rst_n)
  );

  `include "tl_if_connect_macros.svh"
  `include "xbar_tl_if_connection.sv"

  initial begin
    // drive clk and rst_n from clk_if
    clk_rst_if.set_active();
    uvm_config_db#(virtual clk_rst_if)::set(null, "*.env*", "clk_rst_vif", clk_rst_if);
    $timeformat(-12, 0, " ps", 12);
    run_test();
  end

endmodule
